<?php

namespace jrosset\CliProgram\AutoDiscovery;

/**
 * An application with command auto discovery
 */
trait TAutoDiscoveryApplication {
    /**
     * @var AutoDiscoverySpotsList The list of discovery spots
     */
    private AutoDiscoverySpotsList $autoDiscoverySpots;

    /**
     * The list of discovery spots
     *
     * @return AutoDiscoverySpotsList The list of discovery spots
     */
    public function getAutoDiscoverySpots (): AutoDiscoverySpotsList {
        if (!isset($this->autoDiscoverySpots)) {
            $this->autoDiscoverySpots = new AutoDiscoverySpotsList();
        }
        return $this->autoDiscoverySpots;
    }

    /**
     * Add discovered commands to application
     *
     * @return $this
     */
    public function addAutoDiscoveredCommands (): static {
        foreach ($this->getAutoDiscoverySpots() as $autoDiscoverySpot) {
            foreach ($autoDiscoverySpot->getCommands() as $command) {
                $this->add($command);
            }
        }
        return $this;
    }
}